#include <allegro.h>

#include "Grade.h"

Grade::Grade()
{
	Fundo = create_bitmap(400, 400);
	
	clear(Fundo);

	Inicia_Grade();
}

Grade::~Grade()
{
	clear(Fundo);
	
	destroy_bitmap(Fundo);
}

void Grade::Inicia_Grade()
{
	rectfill(Fundo, 0, 0, 400, 400, makecol(0, 0, 0));

	for(int i = 0; i < 10; i ++)
	{
		for(int j = 0; j < 10; j ++)
		{
			if(i%3 != 0)
			{
				if(j%3 != 0)
				{
					vline(Fundo, (15 + 30*i), 15, 285, makecol(0, 255, 0));
					hline(Fundo, 15, (15 + 30*j), 285, makecol(0, 255, 0));
				}
			}

			if((i == 3) || (i == 6))
			{
				if((j == 3) || (j == 6))
				{
					vline(Fundo, (15 + 30*i), 15, 285, makecol(255, 0, 0));
					hline(Fundo, 15, (15 + 30*j), 285, makecol(255, 0, 0));
				}
			}

			if((i == 0) || (i == 9))
			{
				if((j == 0) || (j == 9))
				{
					vline(Fundo, (15 + 30*i), 15, 285, makecol(0, 0, 255));
					hline(Fundo, 15, (15 + 30*j), 285, makecol(0, 0, 255));
				}
			}
		}
	}

	draw_sprite(screen, Fundo, 50, 50);
}
