#include <allegro.h>

#include "Menu.h."

Menu::Menu()
{
	Titulo = load_bitmap("Imagens\\titulo.bmp", Pal);

	Seta = load_bitmap("Imagens\\seta.bmp", Pal);

	Fonte = load_font("Fontes\\Fonte_3.pcx", Pal, NULL);

	Nivel = 1;
}

Menu::~Menu()
{
	destroy_bitmap(Titulo);
}

int Menu::Get_Valor()
{
	bool Prox = false;
	bool Redraw = false;
	
	int X, Y;

	draw_sprite(screen, Titulo, 70, 50);

	draw_sprite(screen, Seta, 70, 215);

	rotate_sprite(screen, Seta, 295, 215, itofix(128));

	textprintf_ex(screen, Fonte, 102, 200, makecol(255, 0, 0), 0, "Nivel %d", Nivel);

	textprintf_ex(screen, Fonte, 135, 300, makecol(0, 0, 255), 0, "Jogar"); 

	do
	{
		if(mouse_b & 1)
		{
			X = mouse_x;
			Y = mouse_y;
		}

		if((Y >= 215) && (Y <= 240))
		{
			if((X >= 70) && (X <= 105))
			{
				Nivel --;

				if(Nivel <= 0) Nivel = 80;

				Redraw = true;
			}

			if((X >= 295) && (X <= 310))
			{
				Nivel ++;

				if(Nivel >= 81) Nivel = 1;

				Redraw = true;
			}

			if(Redraw)
			{
				textprintf_ex(screen, Fonte, 105, 200, makecol(0, 0, 0), 0, "77777777", Nivel); 

				rotate_sprite(screen, Seta, 295, 215, itofix(128));

				textprintf_ex(screen, Fonte, 102, 200, makecol(255, 0, 0), 0, "Nivel %d", Nivel); 

				X = 0;
				Y = 0;

				rest(200);
			}
		}

		if((Y >= 312) && (Y <= 348))
		{
			if((X >= 135) && (X <= 234)) Prox = true;
		}

	}while(!Prox);

	return Nivel;
}
