#include <allegro.h>

#include "Numeros.h"
#include "Grade.h"
#include "Menu.h"

Numeros::Numeros()
{
	Menu Inicio;

	Nivel = Inicio.Get_Valor();

	long ltime;
	short stime;

	ltime = time(NULL);
	stime = (unsigned) ltime/2;

	srand(stime);
	
	Fonte = load_font("Fontes\\Fonte_1.pcx", Pal, NULL);
}

Numeros::~Numeros()
{
	destroy_font(Fonte);
}

void Numeros::Set_Numeros()
{
	Limpa_Matriz();
	
	bool Sorteio_1 = false;
	bool Sorteio_2 = false;
	bool Sorteio_3 = false;

	int I, J;
	int cont_1 = 0;
	int cont_2 = 0;
	int cont_3 = 0;
	int cont_4 = 0;
	int cont_5 = 0;
	int cont_6 = 0;
	int cont_7 = 0;
	int cont_8 = 0;

	textprintf_ex(screen, Fonte, 155, 25, makecol(0, 0, 0), 0, "000000000", Nivel); 
	textprintf_ex(screen, Fonte, 155, 25, makecol(255, 0, 0), 0, "Nivel %d", Nivel); 
	
	for(i = 0; i < 9; i ++)
	{
		for(j = 0; j < 9; j ++)
		{
			Resposta[i][j] = (rand()%9) + 1;

			if((i >= 0) && (i <= 2)) I = 0;
			if((i >= 3) && (i <= 5)) I = 1;
			if((i >= 6) && (i <= 8)) I = 2;

			if((j >= 0) && (j <= 2)) J = 0;
			if((j >= 3) && (j <= 5)) J = 1;
			if((j >= 6) && (j <= 8)) J = 2;

			do
			{
				cont_1 ++;

				Sorteio_1 = Teste_Coluna();
				Sorteio_2 = Teste_Linha();
				Sorteio_3 = Teste_Quadrado(I, J);
				
				if((!Sorteio_1) && (!Sorteio_2) && (!Sorteio_3)) break;
				if((Sorteio_1) || (Sorteio_2 )|| (Sorteio_3)) Resposta[i][j] = (rand()%9) + 1;

				if(cont_1 > 50)
				{
					Limpa_Coluna();
					
					j = -1;

					cont_1 = 0;

					cont_2 ++;

					if(cont_2 > 50)
					{
						i --;

						Limpa_Coluna();

						cont_2 = 0;

						cont_3 ++;

						if(cont_3 > 50)
						{
							i --;

							Limpa_Coluna();

							cont_3 = 0;

							cont_4 ++;

							if(cont_4 > 50)
							{
								i --;

								Limpa_Coluna();

								cont_4 = 0;

								cont_5 ++;

								if(cont_5 > 50)
								{
									i --;

									Limpa_Coluna();

									cont_5 = 0;

									cont_6 ++;

									if(cont_6 > 50)
									{
										i --;

										Limpa_Coluna();

										cont_6 = 0;

										cont_7 ++;

										if(cont_7 > 50)
										{
											i --;

											Limpa_Coluna();

											cont_7 = 0;

											cont_8 ++;

											if(cont_8 > 50) Set_Numeros();
										}
									}
								}
							}
						}
					}
				}

			}while(1 == 1);
		}
	}

	Cria_Jogo();

	Show_Numeros();
}

void Numeros::Show_Numeros()
{
	for(int a = 0; a < 9; a ++)
	{
		for(int b = 0; b < 9; b ++)
		{
			textprintf_ex(screen, Fonte, (72 + 30*a), (70 + 30*b), makecol(0, 0, 0), 0, "0"); 
			if(Jogador[a][b] != 0) textprintf_ex(screen, Fonte, (72 + 30*a), (70 + 30*b), makecol(255, 255, 255), 0, "%d", Jogador[a][b]); 
		}
	}
}

void Numeros::Show_Numero(int a, int b)
{
	textprintf_ex(screen, Fonte, (72 + 30*a), (70 + 30*b), makecol(0, 0, 0), 0, "0"); 
	if(Jogador[a][b] != 0) textprintf_ex(screen, Fonte, (72 + 30*a), (70 + 30*b), makecol(255, 255, 0), 0, "%d", Jogador[a][b]); 
}

bool Numeros::Teste_Linha()
{
	bool Sorteio = false;
	
	int l = 0;

	if(i != 0)
	{	
		do
		{
			if(Resposta[i][j] == Resposta[l][j])
			{
				Sorteio = true;

				break;
			}

			l ++;
		}while(l < i);
	}

	return Sorteio;
}

bool Numeros::Teste_Coluna()
{
	bool Sorteio = false;

	int k = 0;
	
	if(j != 0)
	{
		do
		{
			if(Resposta[i][j] == Resposta[i][k])
			{
				Sorteio = true;

				break;
			}

			k ++;
		}while(k < j);
	}

	return Sorteio;
}

bool Numeros::Teste_Quadrado(int I, int J)
{
	for(int a = 3*I; a <= (3*I + 2); a ++)
	{
		for(int b = 3*J; b <= (3*J + 2); b ++)
		{
			for(int c = 3*I; c <= (3*I + 2); c ++)
			{
				for(int d = 3*J; d <= (3*J + 2); d ++)
				{
					if((a != c) && (b != d))
					{
						if(Resposta[a][b] != 0)
						{
							if(Resposta[a][b] == Resposta[c][d]) return true;
						}
					}
				}
			}
		}
	}

	return false;
}

void Numeros::Cria_Jogo()
{
	Clone_Matriz(false);
	
	int Par, cont, a, b;

	cont = 0;

	do
	{
		for(a = 0; a < 9; a ++)
		{
			for(b = 0; b < 9; b ++)
			{
				Par = (((rand()%81) + 1) - Nivel);
			
				if((Par <= 0) && (cont < Nivel))
				{
					if(Jogador[a][b] != 0)
					{
						Jogador[a][b] = 0;

						cont ++;
					}
				}
			}
		}
	}while((cont < Nivel) || (cont == 0));

	Clone_Matriz(true);
}

void Numeros::Clone_Matriz(bool Tipo)
{
	for(int a = 0; a < 9; a ++)
	{
		for(int b = 0; b < 9; b ++)
		{
			if(!Tipo) Jogador[a][b] = Resposta[a][b];
			else Protecao[a][b] = Jogador[a][b];

			if(Protecao[a][b] == 0) Protecao[a][b] = 10;
		}
	}
}

bool Numeros::Set_Numeros(int Linha, int Coluna, bool Logico)
{
	bool Mudou = false;
	
	if(Protecao[Linha][Coluna] == 10)
	{
		if(Logico) Jogador[Linha][Coluna] ++;
		else Jogador[Linha][Coluna] --;

		if(Jogador[Linha][Coluna] >= 10) Jogador[Linha][Coluna] = 1;
		if(Jogador[Linha][Coluna] <= 0) Jogador[Linha][Coluna] = 9;

		Mudou = true;
	}

	return Mudou;
}

int Numeros::Get_Numeros(int Linha, int Coluna)
{
	return Jogador[Linha][Coluna];
}

void Numeros::Teste_Matriz()
{
	int cont = 0;
	
	for(int a = 0; a < 9; a ++)
	{
		for(int b = 0; b < 9; b ++)
		{
			if(Jogador[a][b] == Resposta[a][b]) cont ++;
		}
	}

	if(cont == 81)
	{
		if(Nivel < 80) Nivel ++;

		Set_Numeros();
	}
}

void Numeros::Limpa_Coluna()
{
	for(int a = 0; a < 9; a ++)
	{
		Resposta[i][a] = 0;
	}
}

void Numeros::Limpa_Matriz()
{
	for(int a = 0; a < 9; a ++)
	{
		for(int b = 0; b < 9; b ++)
		{
			Resposta[a][b] = 0;
			Jogador[a][b] = 0;
			Protecao[a][b] = 0;
		}
	}
}
