#ifndef _NUMEROS_H_
#define _NUMEROS_H_

#include <allegro.h>

#include "Grade.h"

class Numeros
{
private:
	PALETTE Pal;
	
	FONT *Fonte;

	int Resposta[9][9];
	int Jogador[9][9];
	int Protecao[9][9];

	int Nivel;
	int i, j;

public:
	Numeros();
	~Numeros();

	void Set_Numeros();
	void Show_Numeros();
	void Show_Numero(int a, int b);

	bool Teste_Linha();
	bool Teste_Coluna();
	bool Teste_Quadrado(int I, int J);

	void Cria_Jogo();
	void Clone_Matriz(bool Protecao);

	bool Set_Numeros(int Linha, int Coluna, bool Logico);
	int Get_Numeros(int Linha, int Coluna);

	void Teste_Matriz();

	void Limpa_Coluna();
	void Limpa_Matriz();
};

#endif


