#include "Sudoku.h"
#include "Grade.h"
#include "Numeros.h"

Sudoku::Sudoku(Grade *G, Numeros *N)
{
	Num = N;
	Gra = G;

	Fonte = load_font("Fontes\\Fonte_2.pcx", Pal, NULL);

	textprintf_ex(screen, Fonte, 57, 361, makecol(255, 255, 255), 0, "GERAR");

	textprintf_ex(screen, Fonte, 182, 361, makecol(255, 255, 255), 0, "SAIR");

	textprintf_ex(screen, Fonte, 295, 361, makecol(255, 255, 255), 0, "PROX");

	Jogo();
}

Sudoku::~Sudoku()
{
	Num = NULL;
	Gra = NULL;
}

void Sudoku::Jogo()
{
	int X, Y, a, b;

	bool Mudou;
	
	while(!key[KEY_ESC])
	{
		if((mouse_b & 1) || (mouse_b & 2))
		{
			Mudou = false;
			
			X = mouse_x;
			Y = mouse_y;

			if((X <= 335) && (X >= 65) && (Y <= 335) && (Y >= 65))
			{
				a = (int) ((X - 65) / 30);
				b = (int) ((Y - 65) / 30);

				if(mouse_b & 1) Mudou = Num -> Set_Numeros(a, b, true);

				if(mouse_b & 2) Mudou = Num -> Set_Numeros(a, b, false);

				if(Mudou) Num -> Show_Numero(a, b);
			}

			if((Y >= 361) && (Y <= 380))
			{
				if((X >= 57) && (X <= 109)) Num -> Set_Numeros();

				if((X >= 182) && (X <= 216)) break;
				
				if((X >= 295) && (X <= 335)) Num -> Teste_Matriz();
			}

			rest(300);
		}
	};
}
