#include <allegro.h>
#include <cmath>

int main(void)
{
	allegro_init();

	set_color_depth(32);

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0);

	install_keyboard();

	BITMAP *Linha = create_bitmap(1024, 768);
	
	float a = 0;
	float ao = a;

	float ro;
	float PI = 3.14159265;
		
	float Xc = 512;
	float Yc = 384;

	float Xao = Xc + 100;
	float Yao = Yc + 300;

	float Xaf = Xc - 150;
	float Yaf = Yc - 150;
	
	float Xco = Xc;
	float Yco = Yc;

	float M1, M2;

	int S1, S2, S3, S4;

	clear(Linha);
	
	//desenha o "centro"....
    line(Linha, (int) (Xc - 10), (int) Yc, (int) (Xc + 10), (int) Yc, makecol(255, 0, 0));
    line(Linha, (int) Xc, (int) (Yc - 10), (int) Xc, (int) (Yc + 10), makecol(255, 0, 0));
    
    blit(Linha, screen, 0, 0, 0, 0, 1024, 768);

	//clculo do ngulo inicial
	M1 = atan((Yao - Yc)/(Xao - Xc));
	M2 = atan((Yaf - Yc)/(Xaf - Xc));

	if(Xao < Xc) S1 = -1;
	else S1 = 1;

	if(Yao < Yc) S2 = -1;
	else S2 = 1;

	if(Xaf < Xc) S3 = -1;
	else S3 = 1;

	if(Yaf < Yc) S4 = -1;
	else S4 = 1;

	while(!key[KEY_ESC])
	{
		if(key[KEY_UP]) a -= 2;
		if(key[KEY_DOWN]) a += 2;
		
		if(a != ao)
		{
			ro = sqrt((Xao - Xc)*(Xao - Xc) + (Yao - Yc)*(Yao - Yc));
			
			Xao = Xc + ro*S1*cos((a*PI/180) + M1);
			Yao = Yc + ro*S2*sin((a*PI/180) + M1);

			ro = sqrt((Xaf - Xc)*(Xaf - Xc) + (Yaf - Yc)*(Yaf - Yc));
			
			Xaf = Xc + ro*S3*cos((a*PI/180) + M2);
			Yaf = Yc + ro*S4*sin((a*PI/180) + M2);
			
			//desenha a linha a ser rotacionada
	        if(key[KEY_UP]) line(Linha, (int) Xao, (int) Yao, (int) Xaf, (int) Yaf, makecol(0, 255, 0));
	        if(key[KEY_DOWN]) line(Linha, (int) Xao, (int) Yao, (int) Xaf, (int) Yaf, makecol(0, 0, 255));
	        
	        blit(Linha, screen, 0, 0, 0, 0, 1024, 768);

			ao = a;

			rest(50);
		}

		if(key[KEY_ENTER])
        {
            clear(Linha);
            
            //desenha o "centro"....
            line(Linha, (int) (Xc - 10), (int) Yc, (int) (Xc + 10), (int) Yc, makecol(255, 0, 0));
       	    line(Linha, (int) Xc, (int) (Yc - 10), (int) Xc, (int) (Yc + 10), makecol(255, 0, 0));
       	    
            blit(Linha, screen, 0, 0, 0, 0, 1024, 768);
        }
	};

	return 0;
}
END_OF_MAIN();

