#include <allegro.h>

void init();
void desenho_mouse();

BITMAP *mouse, *desenho;
PALLETE pal;

int main()
{
	init();

	desenho_mouse();
	
	return 0;
}
END_OF_MAIN();

void init()
{
	allegro_init();
	
	set_color_depth(32);
	
	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0);
	
	install_timer();
	install_keyboard();
	install_mouse();
	
	mouse = load_bitmap("mouse.bmp",pal);
	desenho = create_bitmap(1024,768);
	
	enable_hardware_cursor();
	set_mouse_sprite(mouse); 
	select_mouse_cursor(MOUSE_CURSOR_ALLEGRO);
	
	set_mouse_range(0, 0, 1024, 768); 
}

void desenho_mouse()
{
   int xa = 0;
   int xb = 0;
   int ya = 0;
   int yb = 0;
   int xao = 0;
   int xbo = 0;
   int yao = 0;
   int ybo = 0;
   
   char info_2[30];
   
   show_mouse(screen);
   freeze_mouse_flag;
   
   while(!key[KEY_ESC])
   {
      if(mouse_b & 1)
      {
         xa = mouse_x;
         ya = mouse_y;
         
         if((xa != xao) || (ya != yao))
         {
            line(desenho,xa,ya,xb,yb,makecol(0,255,0));
            blit(desenho,screen,0,0,0,0,1024,784);
            
            show_mouse(screen);
         }
         
         xao = xa;
         yao = ya;
      }
      
      if(mouse_b & 2)
      {
         xb = mouse_x;
         yb = mouse_y;
         
         if((xb != xbo) || (yb != ybo))
         {
            line(desenho,xa,ya,xb,yb,makecol(0,255,0));
            blit(desenho,screen,0,0,0,0,1024,784);
            
            show_mouse(screen);
         }
         
         xbo = xb;
         ybo = yb;
      }
      
      rest(50);
   };
}
