#include <allegro.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define pi 3.14159265

PALLETE pal;
   
BITMAP *tanque,*linha;

void rotacao();
void init();
void desenha_linha();
void desenho_tanque(int, int, int, float);

int main()
{
	init();
	
	rotacao();

	return 0;
}
END_OF_MAIN();

void init() {
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}

	install_keyboard();
	
	linha = create_video_bitmap(1024,768);
	//tanque = load_bitmap("C:\\Jogos\\AEM Games\\Panzerhaubitze 2000\\Imagens\\carro_jogador_1.bmp",pal);
    tanque = load_bitmap("carro_jogador_1.bmp",pal);
	
}

void rotacao()
{
   int a, x, xo, y, op, temp_x, temp_y, temp_a, i;
   float teste;
   
   a = 0;
   x = 0;
   y = 0;
   
   op = 0;
   
   xo = x;
   
   draw_sprite(screen,tanque,0,475);
   desenha_linha();
         
   while(!key[KEY_ESC])
   {
      if(key[KEY_LEFT])
      {
         x -= 5;
         op = -1;
         
         teste = 0;
         
         if(x < 0) x = 0;
         
         if(x >= 260)
         {
            teste = (x - 260)/5;
            
            if(teste <= 6)
            {
               y = 0;
               a = 0;
            
               y = (y + 3 * teste);
               a = (a - 4 * teste);
            }
            
            else
            {
               a = -32;
               
               if(teste == 7) y = 26;
               
               y -= 5;
            }
            
            if(teste >= 71)
            {
               y = 340;
               
               a = 0;
               
               if(teste == 71)
               {
                  x -= 5;
                  
                  temp_x = x;
                  temp_y = y;
                  temp_a = a;
               
                  for(i = 0; i <= 8; i++)
                  {
                     clear(screen);
               
                     desenha_linha();
                  
                     desenho_tanque(temp_x,temp_y,temp_a,teste);
                     temp_a = (a - 4 * i);
                  
                     sleep(20);
                  }
                  
                  y += 1;
                  
                  x +=5;
                  
                  a = -32;
               }
            }
         }
         
         else a = 0;
      }
      
      if(key[KEY_RIGHT])
      {
         x += 5;
         op = 1;
         
         teste = 0;
         
         if(x > 915) x = 915;
         
         if(x >= 260)
         {
            teste = (x - 260)/5;
            
            if(teste <= 6)
            {
               y = 4;
               a = -4;
            
               y = (y + 3 * teste);
               a = (a - 4 * teste);
            }
            
            else
            {
               a = -32;
               
               if(teste == 7) y = 16;
               
               y += 5;
            }
            
            if (teste >= 72)
            {
               y = 340;
               
               if(teste == 72)
               {
                  x -= 5;
                  y += 1;
                  
                  temp_x = x;
                  temp_y = y;
                  temp_a = a;
               
                  for(i = 0; i <= 8; i++)
                  {
                     clear(screen);
               
                     desenha_linha();
                  
                     desenho_tanque(temp_x,temp_y,temp_a,teste);
                     temp_a = (a + 4 * i);
                  
                     sleep(20);
                  }
               
                  x += 5;
                  y -= 1;
               }
               
               a = 0;
            }
         }
      }
      
      if(x != xo)
      {
         clear(screen);
         
         desenha_linha();
         desenho_tanque(x, y, a, teste);
         
         xo = x;
      }
      
      sleep(60);
   };
}

void desenha_linha()
{
   fastline(linha,0,530,340,530,makecol(0,255,0));
   show_video_bitmap(linha);
   
   fastline(linha,340,530,680,190,makecol(0,255,0));
   show_video_bitmap(linha);
   
   fastline(linha,680,190,1024,190,makecol(0,255,0));
   show_video_bitmap(linha);
}

void desenho_tanque(int x, int y, int a, float teste)
{
   char texto[40];
   
   rotate_sprite(screen, tanque, x, 475 - y, itofix(a));
   
   sprintf(texto,"X: %d   Y: %d   Teste: %.1f   ",x,y,teste);
   textout(screen,font,texto,0,30,makecol(255,0,0));
   
}
