#include <allegro.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define Pi 3.14159265
#define G -9.81

void init();
void movimento();

int ao();
int vo();
int fo();
int dir();
int mo();

char info_2[90];

int main()
{
    init();
    
	movimento();

	return 0;
}
END_OF_MAIN();

void init() 
{
   int depth, res;
   	
   allegro_init();
	
   depth = desktop_color_depth();
   
   if (depth == 0) depth = 32;
   
   set_color_depth(depth);
   	
   res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0);
   
   if (res != 0)
   {
      allegro_message(allegro_error);
	  exit(-1);
   }

   install_keyboard();
}

void movimento()
{
   float Xo, Yo, X, Y, T;
   int xot, yot, xt, yt;
   int A, V, F, M, cont;
   
   const int Ao = ao();
   const int Vo = vo();
   const int Fo = fo();
   int Dir = dir();
   const int Mo = mo();
   
   char sentido;
   
   if(Dir == 1) sentido = 'D';
   else sentido = 'E';
   
   BITMAP *desenho = create_bitmap(1024,768);
   
   Xo = 512;
   Yo = 384;
   
   xot = 512;
   yot = 384;
   
   V = Vo;
   
   T = 0;
   
   for(M = 0; M <= 10; M += 5)
   {
      if (M == 0) M = 1;
      
      for(A = Ao; A <= 135; A ++)
      {
         for(V = Vo; V <= 100; V ++)
         {
            for(F = Fo; F <= 100; F ++)
            {
               cont = 0;
               
               do
               {
                  cont += 1;
                  
                  clear(screen);
                  
                  if(Dir == 1) sentido = 'D';
                  else sentido = 'E';
               
                  sprintf(info_2,"ANGULO ATUAL: %d ",A);
                  textout(screen,font,info_2,0,0,makecol(255,0,0));
               
                  sprintf(info_2,"VELOCIDADE ATUAL: %d ",V);
                  textout(screen,font,info_2,0,30,makecol(255,0,0));
               
                  sprintf(info_2,"FORCA ATUAL: %d ",F);
                  textout(screen,font,info_2,0,60,makecol(255,0,0));
               
                  sprintf(info_2,"DIRECAO ATUAL: %c ",sentido);
                  textout(screen,font,info_2,0,90,makecol(255,0,0));
               
                  sprintf(info_2,"MASSA ATUAL: %d ",M);
                  textout(screen,font,info_2,0,120,makecol(255,0,0));
               
                  sleep(3000);
               
                  clear(screen);
               
                  do
                  {
                     if(A <= 90)
                     {
                        Y = (float) (Yo+((Vo*sin(A*Pi/180)*T)+(G*T*T/2))/100);
                        X = (float) (Xo+((Vo*cos(A*Pi/180)*T)+(Dir*F*T*T/2*M))/100);
                     }
                     
                     else
                     {
                        Y = (float) (Yo+((Vo*sin((A-90)*Pi/180)*T)+(G*T*T/2))/100);
                        X = (float) (Xo+((-Vo*cos((A-90)*Pi/180)*T)+(Dir*F*T*T/2*M))/100);
                     }
                  
                     xt = (int) (X);
                     yt = (int) (Y);
               
                     if(yt >= 1 || yot >= 1)
                     {
                        line(desenho,xot,784-yot,xt,784-yt,makecol(0,255,0));
                        blit(desenho,screen,0,0,0,0,1024,784);
                     }
                  
                     sprintf(info_2,"TEMPO: %.3f   ",T);
                     textout(screen,font,info_2,0,730,makecol(255,0,0));
                   
                     Xo = X;
                     Yo = Y;
                  
                     yot = yt;
                     xot = xt;
                   
                     T += 0.001;
                  
                     if(key[KEY_ENTER]) break;
                     
                     if(key[KEY_ESC]) exit(0);
                  
                     if(yt <= 53 && yot <= 53) break;
                  
                     if(key[KEY_ESC]) exit(0);
                  
                  }while(xt <= 1024 && xt >= 1);
               
                  clear(desenho);
               
                  Xo = 512;
                  Yo = 384;
               
                  xot = 512;
                  yot = 384;
               
                  T = 0;
               
                  sleep(1500);
               
                  Dir = ((-1)*Dir);
               }while(cont != 2);
            }
         }
      }
      
      if(M == 1) M = 0;
   }
}

int ao()
{
    sleep(150);
    
    int Ao = 0;
    
    while (!key[KEY_ESC])
    {
	   sprintf(info_2,"ANGULO INICIAL: %d ",Ao);
       textout(screen,font,info_2,0,0,makecol(255,0,0));
       
       clear_keybuf();
       
       if(key[KEY_LEFT])
       {
          Ao -= 1;
          
          if(Ao < 0) Ao = 0;
       }
       
       if(key[KEY_RIGHT])
       {
          Ao += 1;
          
          if(Ao > 135) Ao = 135;
       }
       
       if(key[KEY_ENTER] || key[KEY_ENTER_PAD]) return(Ao);
       
       sleep(50);
    }
}

int vo()
{
    sleep(150);
    
    int Vo = 0;
    
    while(!key[KEY_ESC])
    {
       sprintf(info_2,"VELOCIDADE INICIAL: %d ",Vo);
       textout(screen,font,info_2,0,30,makecol(255,0,0));
       
       clear_keybuf();
             
       if(key[KEY_LEFT])
       {
          Vo -= 1;
          
          if(Vo < 0) Vo = 0;
       }
       
       if(key[KEY_RIGHT])
       {
          Vo += 1;
          
          if(Vo > 100) Vo = 100;
       }
             
       if(key[KEY_ENTER] || key[KEY_ENTER_PAD]) return(Vo);
       
       sleep(50);
    } 
}

int fo()
{
    sleep(150);
    
    int Fo = 0;
    
    while(!key[KEY_ESC])
    {
       sprintf(info_2,"FORCA INICIAL: %d ",Fo);
       textout(screen,font,info_2,0,60,makecol(255,0,0));
       
       clear_keybuf();
             
       if(key[KEY_LEFT])
       {
          Fo -= 1;
          
          if(Fo < 0) Fo = 0;
       }
       
       if(key[KEY_RIGHT])
       {
          Fo += 1;
          
          if(Fo > 100) Fo = 100;
       }
             
       if(key[KEY_ENTER] || key[KEY_ENTER_PAD]) return(Fo);
       
       sleep(50);
    }
}

int dir()
{
    sleep(150);
    
    int Dir = 1;
    char sentido = ' ';
    
    while(!key[KEY_ESC])
    {
       sprintf(info_2,"DIRECAO INICIAL: %c ",sentido);
       textout(screen,font,info_2,0,90,makecol(255,0,0));
       
       clear_keybuf();
             
       if(key[KEY_LEFT])
       {
          Dir = -1;
          
          sentido = 'E';
       }
       
       if(key[KEY_RIGHT])
       {
          Dir = 1;
          
          sentido = 'D';
       }
             
       if(key[KEY_ENTER] || key[KEY_ENTER_PAD]) return(Dir);
       
       sleep(50);
    }
}

int mo()
{
   sleep(150);
   
   int Mo = 1;
   
   while(!key[KEY_ESC])
   {
      sprintf(info_2,"MASSA INICIAL: %d ",Mo);
      textout(screen,font,info_2,0,120,makecol(255,0,0));
      
      clear_keybuf();
             
      if(key[KEY_LEFT])
      {
         Mo -= 5;
          
         if(Mo <= 0) Mo = 1;
      }
       
      if(key[KEY_RIGHT])
      {
         if(Mo == 1) Mo = 0;
                      
         Mo += 5;
          
         if(Mo > 10) Mo = 10;
      }
             
      if(key[KEY_ENTER] || key[KEY_ENTER_PAD]) return(Mo);
      
      sleep(50);
   } 
}
