#include <allegro.h>
#include <math.h>

void Inicia_Allegro();
void Move_Circulo();
void Desenha_Circulo();
void Inicia_Programa();
void Teste_Colisao(int Xo, int Yo);

BITMAP *Circulos;

int X = 800;
int Y = 600;

int main(void)
{
	Inicia_Programa();

	return 0;
}
END_OF_MAIN();

void Inicia_Allegro()
{
	allegro_init();

	set_color_depth(32);
	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0);

	install_keyboard();

	Circulos = create_bitmap(1024, 768);
}

void Move_Circulo()
{
	if(key[KEY_RIGHT])
	{
		X += 5;
		
		if(X >= 924) X -= 5;
	}

	if(key[KEY_LEFT])
	{
		X -= 5;
		
		if(X <= 100) X += 5;
	}
	
	if(key[KEY_UP])
	{
		Y += 5;
		
		if(Y >= 668) Y -= 5;
	}

	if(key[KEY_DOWN])
	{
		Y -= 5;
		
		if(Y <= 100) Y += 5;
	}
}

void Desenha_Circulo()
{
	clear(Circulos);

	circlefill(Circulos, 512, 768 - 384, 100, makecol(255, 0, 0));

	circlefill(Circulos, X, 768 - Y, 100, makecol(0, 255, 0));

	blit(Circulos, screen, 0, 0, 0, 0, 1024, 768);
}

void Inicia_Programa()
{
	int Xo, Yo;
	
	Inicia_Allegro();

	Xo = X;
	Yo = Y;

	Desenha_Circulo();

	while(!key[KEY_ESC])
	{
		Move_Circulo();

		Teste_Colisao(Xo, Yo);

		if((Xo != X) || (Yo != Y))
		{
			Desenha_Circulo();

			Xo = X;
			Yo = Y;

			rest(5);
		}
	};
}

void Teste_Colisao(int Xo, int Yo)
{
	float D;

	D = sqrt(pow((float)(X - 512), 2) + pow((float)(Y - 384), 2));

	if(D < 200)
	{
		if(X != Xo)
		{
			if(X > Xo) X -= 5;
			else X += 5;
		}

		if(Y != Yo)
		{
			if(Y > Yo) Y -= 5;
			else Y += 5;
		}
	}
}
