#include <allegro.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define pi 3.14159265

PALLETE pal;
   
BITMAP *tanque_1, *tanque_2, *mapa, *restore;

void rotacao();
void init();
void desenha_linha();
void desenho_tanque(int, int, int, int, float);

int main()
{
	init();
	
	rotacao();

	return 0;
}
END_OF_MAIN();

void init() {
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}

	install_keyboard();
	
	tanque_1 = load_bitmap("carro_jogador_1.bmp",pal);
	tanque_2 = load_bitmap("carro_jogador_2.bmp",pal);
	restore = load_bitmap("restore.bmp",pal);
	
	mapa = load_bitmap("terreno_dificil.bmp",pal);
	
	//tanque_1 = load_bitmap("C:\\Jogos\\AEM Games\\Panzerhaubitze 2000\\Imagens\\carro_jogador_1.bmp",pal);
	//tanque_2 = load_bitmap("C:\\Jogos\\AEM Games\\Panzerhaubitze 2000\\Imagens\\carro_jogador_2.bmp",pal);
	//restore = load_bitmap("C:\\Jogos\\AEM Games\\Panzerhaubitze 2000\\Imagens\\restore.bmp",pal);
	
	//mapa = load_bitmap("C:\\Jogos\\AEM Games\\Panzerhaubitze 2000\\Imagens\\terreno_dificil.bmp",pal);
}

void rotacao()
{
   int a, x, xo, y, temp_x, temp_y, temp_a, i, jogador;
   float teste;
   
   jogador = 1;
   
   x = 0;
    
   a = 0;
   x = 0;
   y = 0;
   
   xo = x;
   
   draw_sprite(screen, tanque_1, 0, 509);
   
   draw_sprite(screen, tanque_2, 0, 920);
   
   desenha_linha();
         
   while(!key[KEY_ESC])
   {
      if(((key[KEY_LEFT]) && (jogador == 1)) || ((key[KEY_RIGHT]) && (jogador == 2)))
      {
         x -= 5;
         
         if(x < 0) x = 0;
         
         teste = 0;
         
         if(x == 42)
         {
            x = 45;
            y = 0;
            a = 0;
         }
         
         if(x >= 45)
         {
            teste = (x - 45)/5;
            
            if(teste <= 6)
            {
               y = 0;
               a = 0;
            
               y = (y + 3 * teste);
               a = (a - 4 * teste);
            }
            
            else
            {
               if(teste == 7) x = 80;
               
               a = -32;
               
               y -= 5;
            }
            
            if(teste >= 11)
            {
               y = 40;
               
               a = 0;
               
               if(teste == 11)
               {
                  temp_x = x - 5;
                  temp_y = y;
                  temp_a = a;
               
                  for(i = 0; i <= 8; i++)
                  {
                     desenho_tanque(jogador, temp_x, temp_y, temp_a, teste);
                     temp_a = (a - 4 * i);
                  
                     sleep(20);
                  }
                  
                  y += 4;
                  
                  a = -32;
               }
            }
         }
         
         else a = 0;
      }
      
      if(((key[KEY_RIGHT]) && (jogador == 1)) || ((key[KEY_LEFT]) && (jogador == 2)))
      {
         x += 5;
         
         teste = 0;
         
         if(x >= 45)
         {
            teste = (x - 45)/5;
            
            if(teste > 60) x -= 5;
            
            if(teste <= 6)
            {
               if(teste == 0) x +=2;
               
               y = 4;
               a = -4;
            
               y = (y + 3 * teste);
               a = (a - 4 * teste);
            }
            
            else
            {
               a = -32;
               
               if(teste == 7)
               {
                  y = 18;
                  x = 80;
               }
               
               y += 5;
            }
            
            if((teste >= 12) && (teste <= 60))
            {
               y = 40;
               
               if(teste == 12)
               {
                  y += 1;
                  
                  temp_x = x - 5;
                  temp_y = y;
                  temp_a = a;
               
                  for(i = 0; i <= 8; i++)
                  {
                     desenho_tanque(jogador, temp_x, temp_y, temp_a, teste);
                     temp_a = (a + 4 * i);
                  
                     sleep(20);
                  }
               
                  y -= 1;
               }
               
               a = 0;
               
               if(teste >= 36)
               {
                  desenho_tanque(jogador, x, y, a, teste);
               }
            }
         }
      }
      
      if(x != xo)
      {
         desenho_tanque(jogador, x, y, a, teste);
         
         xo = x;
      }
      
      sleep(60);
   };
}

void desenha_linha()
{
   draw_sprite(screen, mapa, 0, 0);
}

void desenho_tanque(int jogador, int x, int y, int a, float teste)
{
   int yo = 40;
   
   draw_sprite(screen, restore, 0, 384);
   
   if(x >= 245)
   {
      a = 0;
      
      y = 195 - sqrt(pow(150, 2) - pow((x - 245), 2));
      
      yo = 195 - sqrt(pow(150, 2) - pow((x - 250), 2));
      
      if((teste == 40) || (teste == 41)) y -= 4;
      
      if(teste == 42) y -= 4;
      
      if((teste >= 43) && (teste <= 46)) y -= 3;
      
      if(teste == 47) y -= 4;
      
      if((teste == 48) || (teste == 49)) y -= 3;
      
      if((teste >= 50) && (teste <= 52)) y -= 4;
      
      if((teste == 53) || (teste == 54)) y -= 3;
      
      if((teste == 55) || (teste == 56)) y -= 3;
      
      if((teste >= 57) && (teste <= 58)) y -= 2;
      
      if((teste == 59) || (teste == 60)) y -= 1;
      
      //////////////////////////////////////////////////////////////////////////
      
      if((teste == 40) || (teste == 41)) a = -1;
      
      if((teste == 42) || (teste == 43)) a = -3;
      
      if((teste >= 44) && (teste <= 48)) a = (40 - teste);
      
      if((teste == 49) || (teste == 50)) a = -(11 + (teste - 49));
      
      if((teste >= 51) && (teste <= 59)) a = -(15 + 2*(teste - 51));
      
      if(teste == 60) a = -32;
      
      if(a == -31) a = -30;
   }
   
   rotate_sprite(screen, tanque_1, x, 514 - y, itofix(a));
   rotate_sprite(screen, tanque_2, 915 - x, 514 - y, itofix(-a));
}
